// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package configuration

import parser "github.com/haproxytech/config-parser/v5"

type Parser interface {
	Parser() parser.Parser
	HasParser(transactionID string) bool
	GetParser(transactionID string) (parser.Parser, error)
	AddParser(transactionID string) error
	DeleteParser(transactionID string) error
	CommitParser(transactionID string) error
	GetVersion(transactionID string) (int64, error)
	IncrementVersion() error
	LoadData(filename string) error
	Save(transactionFile, transactionID string) error
}
