// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"encoding/json"
	"strconv"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// Compression compression
//
// swagger:model compression
type Compression struct {

	// algorithms
	Algorithms []string `json:"algorithms,omitempty"`

	// offload
	Offload bool `json:"offload,omitempty"`

	// types
	Types []string `json:"types,omitempty"`
}

// Validate validates this compression
func (m *Compression) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateAlgorithms(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

var compressionAlgorithmsItemsEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["identity","gzip","deflate","raw-deflate"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		compressionAlgorithmsItemsEnum = append(compressionAlgorithmsItemsEnum, v)
	}
}

func (m *Compression) validateAlgorithmsItemsEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, compressionAlgorithmsItemsEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *Compression) validateAlgorithms(formats strfmt.Registry) error {
	if swag.IsZero(m.Algorithms) { // not required
		return nil
	}

	for i := 0; i < len(m.Algorithms); i++ {

		// value enum
		if err := m.validateAlgorithmsItemsEnum("algorithms"+"."+strconv.Itoa(i), "body", m.Algorithms[i]); err != nil {
			return err
		}

	}

	return nil
}

// ContextValidate validates this compression based on context it is used
func (m *Compression) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *Compression) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *Compression) UnmarshalBinary(b []byte) error {
	var res Compression
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
