// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"encoding/json"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// Ring Ring
//
// # HAProxy ring configuration
//
// swagger:model ring
type Ring struct {

	// description
	Description string `json:"description,omitempty"`

	// format
	// Enum: [iso local raw rfc3164 rfc5424 short priority timed]
	Format string `json:"format,omitempty"`

	// maxlen
	Maxlen *int64 `json:"maxlen,omitempty"`

	// name
	// Required: true
	// Pattern: ^[A-Za-z0-9-_.:]+$
	Name string `json:"name"`

	// size
	Size *int64 `json:"size,omitempty"`

	// timeout connect
	TimeoutConnect *int64 `json:"timeout_connect,omitempty"`

	// timeout server
	TimeoutServer *int64 `json:"timeout_server,omitempty"`
}

// Validate validates this ring
func (m *Ring) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateFormat(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateName(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

var ringTypeFormatPropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["iso","local","raw","rfc3164","rfc5424","short","priority","timed"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		ringTypeFormatPropEnum = append(ringTypeFormatPropEnum, v)
	}
}

const (

	// RingFormatIso captures enum value "iso"
	RingFormatIso string = "iso"

	// RingFormatLocal captures enum value "local"
	RingFormatLocal string = "local"

	// RingFormatRaw captures enum value "raw"
	RingFormatRaw string = "raw"

	// RingFormatRfc3164 captures enum value "rfc3164"
	RingFormatRfc3164 string = "rfc3164"

	// RingFormatRfc5424 captures enum value "rfc5424"
	RingFormatRfc5424 string = "rfc5424"

	// RingFormatShort captures enum value "short"
	RingFormatShort string = "short"

	// RingFormatPriority captures enum value "priority"
	RingFormatPriority string = "priority"

	// RingFormatTimed captures enum value "timed"
	RingFormatTimed string = "timed"
)

// prop value enum
func (m *Ring) validateFormatEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, ringTypeFormatPropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *Ring) validateFormat(formats strfmt.Registry) error {
	if swag.IsZero(m.Format) { // not required
		return nil
	}

	// value enum
	if err := m.validateFormatEnum("format", "body", m.Format); err != nil {
		return err
	}

	return nil
}

func (m *Ring) validateName(formats strfmt.Registry) error {

	if err := validate.RequiredString("name", "body", m.Name); err != nil {
		return err
	}

	if err := validate.Pattern("name", "body", m.Name, `^[A-Za-z0-9-_.:]+$`); err != nil {
		return err
	}

	return nil
}

// ContextValidate validates this ring based on context it is used
func (m *Ring) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *Ring) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *Ring) UnmarshalBinary(b []byte) error {
	var res Ring
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
